#include "point2D.h"
#include "line2D.h"
#include "region2D.h"
#include <iostream>
#include <stdlib.h>
#include "mSlob.h"
#include <oci.h>
#include "TopPred2D.h"
#include <fstream>
#include <sstream>
#include <cmath>
//#include "statusHseg2D.h"
//#include "SweepLine.h"
using namespace stu;

typedef struct OCILobWrapper{
	OCILobLocator* lob;
	OCISvcCtx*	cntxt;
	OCIError* errhp;
} OCILobWrapper;

static text *username = (text *) "rpraing";
static text *password = (text *) "mypass";

static OCIEnv *envhp;
static OCIError *errhp;
static sword status;

static void checkerr(OCIError *errhp, sword status)
{
	text errbuf[512];
	//ub4 buflen;
	sb4 errcode;
	string er;
	
	if (status == OCI_SUCCESS) return;

	switch (status)
	{
		case OCI_SUCCESS_WITH_INFO:
			cout << "Error - OCI_SUCCESS_WITH_INFO" << endl;
			OCIErrorGet ((dvoid *) errhp, (ub4) 1, (text *) NULL, &errcode,
						  errbuf, (ub4) sizeof(errbuf), (ub4) OCI_HTYPE_ERROR);
			er=(char*)errbuf;
			cout << "Error -" << er << endl;
			break;
		case OCI_NEED_DATA:
			cout << "Error - OCI_NEED_DATA" << endl;
			break;
		case OCI_NO_DATA:
			cout << "Error - OCI_NO_DATA" << endl;
			break;
		case OCI_ERROR:
			OCIErrorGet ((dvoid *) errhp, (ub4) 1, (text *) NULL, &errcode,
						  errbuf, (ub4) sizeof(errbuf), (ub4) OCI_HTYPE_ERROR);
			er=(char*)errbuf;
			cout << "Error -" << er << endl;
			break;
		case OCI_INVALID_HANDLE:
			cout << "Error - OCI_INVALID_HANDLE" << endl;
			break;
		case OCI_STILL_EXECUTING:
			cout << "Error - OCI_STILL_EXECUTING" << endl;
			break;
		case OCI_CONTINUE:
			cout << "Error - OCI_CONTINUE" << endl;
			break;
		default:
			cout << "Error - " << status << endl;
			break;
	}
}

string cutLine(string& in)
{
	int pos=in.find('\n');
	string temp=in.substr(0,pos);
	in=in.substr(pos+1);
	return temp;
}
string cutToken(string& in)
{
	string temp;
	int pos=in.find(' ');
	if (pos==string::npos) //no space " " found, must be last token
	{
		temp=in;
		in="";
	}
	else
	{
		temp=in.substr(0,pos);
		in=in.substr(pos+1);
	}
	return temp;		
}
string itoa(int n)
{
	stringstream converter;
	converter << n;
	return converter.str();
}
int main ()
{

	Locator slobby;
	OCILobLocator *mylob, *mylob2;
	uint did, did2;
	string option;
	
	//cout << "Test: " << sizeof(uint) << endl;
	
	OCISession *authp = (OCISession *) 0;
	OCIServer *srvhp;
	OCISvcCtx *svchp;
	OCIStmt	*stmthp;
	OCIStmt	*stmthp2;
	OCIDefine *defnp = (OCIDefine *) 0;
	OCIDefine *defnp2 = (OCIDefine *) 0;
	OCIDefine *defnp3 = (OCIDefine *) 0;
	OCIDefine *defnp4 = (OCIDefine *) 0;
			
	try{

		
		cout << "creating connection...";
		
/*		OCISession *authp = (OCISession *) 0;
		OCIServer *srvhp;
		OCISvcCtx *svchp;
		OCIStmt	*stmthp;
		OCIDefine *defnp = (OCIDefine *) 0;
		OCIDefine *defnp2 = (OCIDefine *) 0;*/
	
	//create environment and 	//allocate handles and data structures
		(void) OCIInitialize((ub4) OCI_DEFAULT, (dvoid *)0,
		(dvoid * (*)(dvoid *, size_t)) 0,
		(dvoid * (*)(dvoid *, dvoid *, size_t))0,
		(void (*)(dvoid *, dvoid *)) 0 );

		(void) OCIEnvInit( (OCIEnv **) &envhp, OCI_DEFAULT, (size_t) 0,
		(dvoid **) 0 );

		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &errhp, OCI_HTYPE_ERROR,
		(size_t) 0, (dvoid **) 0);

		/* server contexts */
		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &srvhp, OCI_HTYPE_SERVER,
		(size_t) 0, (dvoid **) 0);

		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &svchp, OCI_HTYPE_SVCCTX,
		(size_t) 0, (dvoid **) 0);

		(void) OCIServerAttach( srvhp, errhp, (text *)"berlin.dbcenter.cise.ufl.edu:1521/orastu1", strlen("berlin.dbcenter.cise.ufl.edu:1521/orastu1"), 0);

		/* set attribute server context in the service context */
		(void) OCIAttrSet( (dvoid *) svchp, OCI_HTYPE_SVCCTX, (dvoid *)srvhp,
		(ub4) 0, OCI_ATTR_SERVER, (OCIError *) errhp);

		(void) OCIHandleAlloc((dvoid *) envhp, (dvoid **)&authp,
		(ub4) OCI_HTYPE_SESSION, (size_t) 0, (dvoid **) 0);

		(void) OCIAttrSet((dvoid *) authp, (ub4) OCI_HTYPE_SESSION,
		(dvoid *) username, (ub4) strlen((char *)username),
		(ub4) OCI_ATTR_USERNAME, errhp);

		(void) OCIAttrSet((dvoid *) authp, (ub4) OCI_HTYPE_SESSION,
		(dvoid *) password, (ub4) strlen((char *)password),
		(ub4) OCI_ATTR_PASSWORD, errhp);

	//connect to server and being session
		checkerr(errhp, OCISessionBegin ( svchp,  errhp, authp, OCI_CRED_RDBMS,
				 (ub4) OCI_DEFAULT));

		(void) OCIAttrSet((dvoid *) svchp, (ub4) OCI_HTYPE_SVCCTX,
		(dvoid *) authp, (ub4) 0,
		(ub4) OCI_ATTR_SESSION, errhp);
		
		cout << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\bConnection created succesfully!" << endl;
			
		bool quit=false;
		
		while (!quit){
			cout << "You wanna read(r) and object or load(l) objects from an xfig file?? ('quit' if done): ";
			cin >> option;
		
			if (option=="r"){ //then select data and read
				
				string id;
				string type;
				cout << "1: point2D\n2: line2D\n3: region2D\n";
				cout << "Please select the type of object to be read: ";
				cin >> type;
				cout << "Please give me the id of the object to be retrieved: ";
				cin >> id;
				
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
				
				//allocate lob descriptor
				if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
					(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
				{
					cout << "FAILED: OCIDescriptorAlloc()" << endl;
					return OCI_ERROR;
				}
				
				string sqlQuery = "SELECT id,data FROM mymslob where id=" + id;// + " FOR UPDATE";
				
					//issue SQL and process data
				checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
						 (ub4)strlen(sqlQuery.c_str()),
						 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
	
	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
						 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
						 (ub2 *)0, OCI_DEFAULT));

	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
						 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
						 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
				/* execute and fetch */
				if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
				{
					if (status == OCI_NO_DATA)
						cout << "No data returned!" << endl;
					else
					{
						checkerr(errhp, status);
						if (envhp)
							(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
						return OCI_ERROR;
					}
				}//else success then processs

				if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
				{
					
					//cout << "The COUNT: " << points_getCount(blob1) << endl;
					
					OCILobWrapper *blob1=new OCILobWrapper;
					blob1->lob=mylob;
					blob1->cntxt=svchp;
					blob1->errhp=errhp;
					
					mSlob p(blob1);
					Locator daddy(p.locateGlobal());
					Locator obj(daddy.locate(0));
					cout << "Global: "; obj.debug();
					if(type=="1")
					{
						cout << "mSLOB Built from point with id " << did << endl;
						point2D ps(obj);
						cout << "The point: " << ps << endl;
					}
					else if(type == "2")
					{
						cout << "mSLOB Built from line with id " << did << endl;
						line2D ps(obj);
						cout << "The halfsegments: " << ps << endl;
						cout << "By Blocks..." << endl;
						for (uint i=0; i<ps.getBlockCount(); i++){
							cout << "Block " << (i+1) << ": " << ps.getBlock(i) << endl;
						}
					}
					else if(type == "3")
					{
						cout << "mSLOB Built from region with id " << did << endl;
						region2D ps(obj);
						cout << "The halfsegments: " << ps << endl;
						cout << "By Faces..." << endl;
						for (uint i=0; i<ps.getFaceCount(); i++){
							cout << "Face " << (i+1) << ": " << ps.getFace(i) << endl;
						}
					}
					
					checkerr(errhp, OCILobClose(svchp, errhp, mylob));
					delete blob1;
					blob1 = NULL;
	
				}else
					cout << "No object with id=" << id << " found." << endl;
					
					//free the statement handle	
					checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
			}else if (option=="l"){ //load
				string id;
				uint did;
				string type;
				cout << "1: point2D x point2D\n2: point2D x line2D\n3: point2D x region2D\n4: line2D x line2D\n5: line2D x region2D\n6: region2D x region2D\n";
				cout << "Please select the type combination to load: ";
				cin >> type;
				
				mylob=NULL;
				
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
						OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
				
				//allocate lob descriptor
				if (mylob==NULL){
					if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
						(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
					{
						cout << "FAILED: OCIDescriptorAlloc()" << endl;
						return OCI_ERROR;
					}
				}
				string sqlQuery;
				if(type=="1")
				{
					cout<<"Removing tuple id between 1000 and 2000\n";
					sqlQuery = "DELETE FROM mymslob where id>=1000 AND id <2000";
				}
				else if(type=="2")
				{
					cout<<"Removing tuple id between 2000 and 3000\n";
					sqlQuery = "DELETE FROM mymslob where id>=2000 AND id <3000";
				}
				else if(type=="3")
				{
					cout<<"Removing tuple id between 3000 and 4000\n";
					sqlQuery = "DELETE FROM mymslob where id>=3000 AND id <4000";
				}
				else if(type=="4")
				{
					cout<<"Removing tuple id between 4000 and 5000\n";
					sqlQuery = "DELETE FROM mymslob where id>=4000 AND id <5000";
				}
				else if(type=="5")
				{
					cout<<"Removing tuple id between 5000 and 6000\n";
					sqlQuery = "DELETE FROM mymslob where id>=5000 AND id <6000";
				}
				else if(type=="6")
				{
					cout<<"Removing tuple id between 6000 and 7000\n";
					sqlQuery = "DELETE FROM mymslob where id>=6000 AND id <7000";
				}
				//issue SQL and process data
				checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
					 (ub4)strlen(sqlQuery.c_str()),
					 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
				checkerr(errhp, OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					 (CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT));
				if (stmthp)
					checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
				cout << "Tuples deleted. Ready for loading... "<< endl;
				
				string f="";
				int dbid = 0;
				switch(atoi(type.c_str()))
				{
					case 1:
						f = "topPoint1.fig";
						dbid = 1000;
						break;
					case 2:
						f = "topPL1.fig";
						dbid = 2000;
						break;
					case 3:
						f = "topPR1.fig";
						dbid = 3000;
						break;
					case 4:
						f = "topLine1.fig";
						dbid = 4000;
						break;
					case 5:
						f = "topLR1.fig";
						dbid = 5000;
						break;
					case 6:
						f = "topRegion1.fig";
						dbid = 6000;
						break;
				}
				//	element *e; //temporary for constructing new elements
				string temp;
				string loader;
				string name; //name of coming data
				string header;
				//cout<<"HERE\n";
				std::ifstream fin(f.c_str());
				if (fin.is_open())
				{
					while (!fin.eof() )
					{
						checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
								OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
					
						//allocate lob descriptor
						if (mylob==NULL){
							if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
									(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
							{
								cout << "FAILED: OCIDescriptorAlloc()" << endl;
								return OCI_ERROR;
							}
						}
						std::getline (fin,temp);
						if (temp.substr(0,4)=="#FIG") //then its an xfig file, ignore next 8 lines
						{	
							for (int i=0; i<8; i++) 
								std::getline (fin,temp);
						}
						else if (temp[0]=='#') //then its a comment with info in it
						{
							/*info 
							# 0 name (for points)
							# 1 name (for lines), just read segments
							# 2 numfaces name (for region)
							# 3 numcycles (for faces) name (same as region's)
							*/
							header=temp;
							loader=header + "\n";
							name=header.substr(header.find_last_of(' ')+1);
							std::getline(fin,temp); //discard 6... line
							std::getline(fin,temp);
							while (temp[0]!='-') //while there are more poi2Ds
							{
								loader=loader + temp + "\n";
								std::getline(fin,temp);
							}
							if (header[2]=='0') //then its a point2D object,
							{
								string iid = name.substr(1);
								int xrdbid = dbid + atoi(iid.c_str());
								string rdbid = itoa(xrdbid);
								cout << "Loading Point: " << rdbid << endl;
								sqlQuery = "insert into mymslob values( " + rdbid + ", EMPTY_BLOB())";
								checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
										(ub4)strlen(sqlQuery.c_str()),
										(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
								checkerr(errhp, OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
										(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT));
								cout << "Inserted new tuple with empty blob and id " << rdbid << endl;
								if (stmthp)
									checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
								
								//Select it back
								checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
										OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
					
								//allocate lob descriptor
								if (mylob==NULL){
									if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
										(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
									{
										cout << "FAILED: OCIDescriptorAlloc()" << endl;
										return OCI_ERROR;
									}
								}
								sqlQuery = "SELECT id,data FROM mymslob where id=" + rdbid;// + " FOR UPDATE";
				
								//issue SQL and process data
								checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
										(ub4)strlen(sqlQuery.c_str()),
										(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
								checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
										(sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
										(ub2 *)0, OCI_DEFAULT));
								checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
										(dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
										(dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
								/* execute and fetch */
								if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
										(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
								{
									if (status == OCI_NO_DATA)
										cout << "No data returned!" << endl;
									else
									{
										checkerr(errhp, status);
										if (envhp)
										(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
										return OCI_ERROR;
									}
								}//else success then processs
								if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
								{
									OCILobWrapper *blob1=new OCILobWrapper;
									blob1->lob=mylob;
									blob1->cntxt=svchp;
									blob1->errhp=errhp;
					
									mSlob p(blob1);
					
									Locator daddy(p.locateGlobal());
									if (daddy.getElements()==0) //then build an object node
										daddy.insert(0,OBJECT_LEVEL);
					
									Locator obj(daddy.locate(0));
					
									cout << "Global created: "; obj.debug();
									point2D ps(obj);
									cout << "Point with ID: " << did << " ready for update..." << endl;
									string xheader=cutLine(loader); //main header, not nead here.
									string xtemp=cutLine(loader);
									while (xtemp!="")
									{
										int eofx=xtemp.find(' ',36);
										int eofy=xtemp.find(' ',eofx+1);
										string x=xtemp.substr(36,eofx-36);
										string y=xtemp.substr(eofx+1,eofy-(eofx+1));
										poi2D* np=new poi2D(rat(x),rat(y));
										cout << "Built pointy: " << *np << endl;
										ps.addPoint(*np);	
										xtemp=cutLine(loader);
									}
									checkerr(errhp, OCILobClose(svchp, errhp, mylob));
									checkerr(errhp, OCITransCommit(svchp, errhp, (ub4)0));
									delete blob1;
								}else
									cerr << "Problem retrieving newly created tuple" << endl;
								checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
							}
							else	 if (header[2]=='1') //then its a line2D object,
							{
								string iid = name.substr(1);
								int xrdbid;
								if(type == "2")
									xrdbid = dbid + 500 + atoi(iid.c_str());
								else
									xrdbid = dbid + atoi(iid.c_str());
								string rdbid = itoa(xrdbid);
								cout << "Loading Line: " << rdbid << endl;
								sqlQuery = "insert into mymslob values( " + rdbid + ", EMPTY_BLOB())";
								checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
										(ub4)strlen(sqlQuery.c_str()),
										(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
								checkerr(errhp, OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
										(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT));
								cout << "Inserted new tuple with empty blob and id " << rdbid << endl;
								if (stmthp)
									checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
								
								//Select it back
								checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
										OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
					
								//allocate lob descriptor
								if (mylob==NULL){
									if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
										(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
									{
										cout << "FAILED: OCIDescriptorAlloc()" << endl;
										return OCI_ERROR;
									}
								}
								sqlQuery = "SELECT id,data FROM mymslob where id=" + rdbid;// + " FOR UPDATE";
				
								//issue SQL and process data
								checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
										(ub4)strlen(sqlQuery.c_str()),
										(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
								checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
										(sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
										(ub2 *)0, OCI_DEFAULT));
								checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
										(dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
										(dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
								/* execute and fetch */
								if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
										(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
								{
									if (status == OCI_NO_DATA)
										cout << "No data returned!" << endl;
									else
									{
										checkerr(errhp, status);
										if (envhp)
										(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
										return OCI_ERROR;
									}
								}//else success then processs
								if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
								{
									OCILobWrapper *blob1=new OCILobWrapper;
									blob1->lob=mylob;
									blob1->cntxt=svchp;
									blob1->errhp=errhp;
					
									mSlob p(blob1);
					
									Locator daddy(p.locateGlobal());
									if (daddy.getElements()==0) //then build an object node
										daddy.insert(0,OBJECT_LEVEL);
					
									Locator obj(daddy.locate(0));
					
									cout << "Global created: "; obj.debug();
									
									obj.beginBatch();
									line2D ps(obj);
									cout << "Line with ID: " << did << " ready for update..." << endl;
									
									string header,bheader,cdata;
									string snum;
									int numpoints,numblocks;
									poi2D *p1;
									poi2D *q;
									string x,y;

									header=cutLine(loader); //get line header
									snum=header.substr(4,header.find(' ',4)-4);
									numblocks=atoi(snum.c_str());
									for (int c=0; c<numblocks; c++)
									{
										bheader=cutLine(loader); //get block header
										snum=bheader.substr(38);
										numpoints=atoi(snum.c_str()); //number of points in component
										p1=NULL;
										q=NULL;
										block2D bl=ps.addBlock();
										for (int i=0; i<ceil(numpoints/6.0); i++) //for each line of points for component
										{
											string temp=cutLine(loader); //get the line
											temp=temp.substr(2); //get rid of initial identation
											if (p1==NULL)//first point
											{
												x=cutToken(temp);
												y=cutToken(temp);
												p1=new poi2D(*(new rat(x)),*(new rat(y)));
											}
											//else point p comes from previous line
											while (temp!="")
											{	
												//retrieve new point
												x=cutToken(temp);
												y=cutToken(temp);
												q=new poi2D(*(new rat(x)),*(new rat(y)));
												seg2D *ss=new seg2D(*p1,*q);
												bl.addSegment(*ss);
												p1=new poi2D(*q);
											}
										}
										bl.validate();
									}
									ps.validate();
									obj.commitBatch();
									checkerr(errhp, OCILobClose(svchp, errhp, mylob));
									checkerr(errhp, OCITransCommit(svchp, errhp, (ub4)0));
									delete blob1;
								}else
									cerr << "Problem retrieving newly created tuple" << endl;
									checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
							}
							else	 if (header[2]=='2') //then its a region2D object,
							{
								string iid = name.substr(1);
								int xrdbid;
								if(type == "3" || type == "5")
									xrdbid = dbid + 500 + atoi(iid.c_str());
								else
									xrdbid = dbid + atoi(iid.c_str());
								string rdbid = itoa(xrdbid);
								cout << "Loading Region: " << rdbid << endl;
								sqlQuery = "insert into mymslob values( " + rdbid + ", EMPTY_BLOB())";
								checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
										(ub4)strlen(sqlQuery.c_str()),
										(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));
								checkerr(errhp, OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
										(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT));
								cout << "Inserted new tuple with empty blob and id " << rdbid << endl;
								if (stmthp)
									checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
								
								//Select it back
								checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
										OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
					
								//allocate lob descriptor
								if (mylob==NULL){
									if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
										(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
									{
										cout << "FAILED: OCIDescriptorAlloc()" << endl;
										return OCI_ERROR;
									}
								}
								sqlQuery = "SELECT id,data FROM mymslob where id=" + rdbid;// + " FOR UPDATE";
				
								//issue SQL and process data
								checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
										(ub4)strlen(sqlQuery.c_str()),
										(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
								checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
										(sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
										(ub2 *)0, OCI_DEFAULT));
								checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
										(dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
										(dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
								/* execute and fetch */
								if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
										(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
								{
									if (status == OCI_NO_DATA)
										cout << "No data returned!" << endl;
									else
									{
										checkerr(errhp, status);
										if (envhp)
										(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
										return OCI_ERROR;
									}
								}//else success then processs
								if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
								{
									OCILobWrapper *blob1=new OCILobWrapper;
									blob1->lob=mylob;
									blob1->cntxt=svchp;
									blob1->errhp=errhp;
					
									mSlob p(blob1);
					
									Locator daddy(p.locateGlobal());
									if (daddy.getElements()==0) //then build an object node
										daddy.insert(0,OBJECT_LEVEL);
					
									Locator obj(daddy.locate(0));
					
									cout << "Global created: "; obj.debug();
									
									obj.beginBatch();
									region2D ps(obj);
									cout << "Region with ID: " << did << " ready for update..." << endl;
									
									string rheader,fheader,cdata;
									string snum;
									int numpoints,numcycles,numfaces;
									poi2D *px;
									poi2D *q;
//									poly2D *polygon;
//									face2D *face;
									string x,y;
		
									rheader=cutLine(loader); //region header
									snum=rheader.substr(4,rheader.find(' ',4)-4);
									numfaces=atoi(snum.c_str());
									for (int f=0; f<numfaces; f++) //while there are no more faces
									{
										face2D f1=ps.addFace();
										fheader=cutLine(loader); //get face header
										snum=fheader.substr(4);
										numcycles=atoi(snum.c_str());
										for (int c=0; c<numcycles; c++)
										{
											cdata=cutLine(loader);
											snum=cdata.substr(38);
											numpoints=atoi(snum.c_str()); //number of points in component
											px=NULL;
											q=NULL;
											if(c==0)
											{
												poly2D p1=f1.addOuterCycle();
												for (int i=0; i<ceil(numpoints/6.0); i++) //for each line of points for component
												{
												string temp=cutLine(loader); //get the line
												temp=temp.substr(2); //get rid of initial identation
												if (px==NULL)//first point
												{
												x=cutToken(temp);
												y=cutToken(temp);
												px=new poi2D(*(new rat(x)),*(new rat(y)));
												}
														//else point p comes from previous line
												while (temp!="")
												{	
															//retrieve new point
												x=cutToken(temp);
												y=cutToken(temp);
												q=new poi2D(*(new rat(x)),*(new rat(y)));
									//						cout << "Point p: "<<*p << " Point q: " << *q ;
												bool ia;
												if (c==0) //outercycle, setting ia based on clockwise order
												ia=true;//((*p)<(*q));
												else
												ia=false;//((*p)>(*q));
									//						cout <<	" ia: " << ia <<endl;
												//hseg2D tseg(*px,*q,ia);
												//tseg.finalize();
												seg2D seg(*px,*q);
															//seg.finalize();
												p1.addSegment(seg);
												px=new poi2D(*q);
												}
												}
												p1.validate();
											}
											else
											{
												poly2D p1 = f1.addHole();
												for (int i=0; i<ceil(numpoints/6.0); i++) //for each line of points for component
												{
												string temp=cutLine(loader); //get the line
												temp=temp.substr(2); //get rid of initial identation
												if (px==NULL)//first point
												{
												x=cutToken(temp);
												y=cutToken(temp);
												px=new poi2D(*(new rat(x)),*(new rat(y)));
												}
														//else point p comes from previous line
												while (temp!="")
												{	
															//retrieve new point
												x=cutToken(temp);
												y=cutToken(temp);
												q=new poi2D(*(new rat(x)),*(new rat(y)));
									//						cout << "Point p: "<<*p << " Point q: " << *q ;
												bool ia;
												if (c==0) //outercycle, setting ia based on clockwise order
												ia=true;//((*p)<(*q));
												else
												ia=false;//((*p)>(*q));
									//						cout <<	" ia: " << ia <<endl;
												//hseg2D tseg(*px,*q,ia);
												//tseg.finalize();
												seg2D seg(*px,*q);
															//seg.finalize();
												p1.addSegment(seg);
												px=new poi2D(*q);
												}
												}
												p1.validate();
											}
										}
										f1.validate();
									}
									ps.validate();
									obj.commitBatch();
									checkerr(errhp, OCILobClose(svchp, errhp, mylob));
									checkerr(errhp, OCITransCommit(svchp, errhp, (ub4)0));
									delete blob1;
								}else
									cerr << "Problem retrieving newly created tuple" << endl;
									checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
							}
						}
						else //i wonder...just dismiss
						{}
					}
					fin.close();
				}
			}else{ 
				if (option=="quit")
					quit=true;
			}
		}
		
		cout << "Thanks for testing with us!!!" << endl;
		cout << "Closing connection" << endl;
		if (srvhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SERVER);
		if (svchp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SVCCTX);
		if (errhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_ERROR);
		if (envhp)
			(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
	}
	catch (exception &excp)
	{
		cerr << excp.what() << endl;
		cout << "Thanks...sorry we ended this on such a bad note." << endl;
		cout << "Closing connection" << endl;
		
		if (srvhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SERVER);
		if (svchp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SVCCTX);
		if (errhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_ERROR);
		if (envhp)
			(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
	}
}


