#include <oci.h>
//#include "rational.h"
#include "point2D.h"
#include "mSlob.h"

//Spal2D points wrapper library
//Alejandro Pauly
//Created: 10/24/2006
extern "C" typedef struct OCILobWrapper{
	OCILobLocator* lob;
	OCISvcCtx*     cntxt;
	OCIError*      errhp;
} OCILobWrapper;

extern "C" int point_getCount(OCIExtProcContext *ctx, OCILobLocator* point){
	OCIEnv   *envhp;
	OCISvcCtx  *svchp;
	OCIError   *errhp;
	sword  retval;
	retval = OCIExtProcGetEnv (ctx, &envhp, &svchp, &errhp);

	OCILobWrapper *b=new OCILobWrapper;
	b->lob=point;
	b->errhp=errhp;
	b->cntxt=svchp;

	mSlob p(b);
	
	Locator points(p.locateGlobal());
	
	point2D ps(points.locate(0));
	
	int cc=(int)ps.getPointCount();
	return cc;
/*	int cc=(int)p.count(points);
	return cc;*/
}


