
#include "segment.h"
#include <fstream>
#include <string>
#include <iostream>
#include <ctype.h>
#include <vector>

using namespace std;

#ifndef FILEREADER_H
#define FILEREADER_H
class fileReader
{
	private:
		string fileName;
		
	public:
		fileReader( string & fname ): fileName( fname )
		{	}
		
		//reads the segment info from a file
		int readFile( vector<segment> & segs )
		{
			ifstream file;
			
			// open the file, and create segments for each segment in the file
			string buf;
			double doubleBuf1, doubleBuf2, doubleBuf3, doubleBuf4;
			char charBuf;
			
			file.open( fileName.c_str() );
			if( !file )
			{
				cerr<<"Could not open file: "<<fileName<<endl;
				exit( 1 );
			}
			
			//read the first line to start off
			while( !file.eof() )
			{	

				if( !isdigit( file.peek() ) )
				{	
					file.ignore( 1000000, '\n' );
					continue;
				}
				
				file>>doubleBuf1;
				file>>doubleBuf2;
				file>>doubleBuf3;
				file>>doubleBuf4;
				segs.push_back( segment( doubleBuf1, doubleBuf2, doubleBuf3, doubleBuf4 ) );
				
			}
			
			if(	file.is_open( ) )
				file.close( );
		
			//print test
			//for( int i = 0; i < segs.size(); i++ )
			//	cout<< segs[i]<<endl;
			
			
		}
};
#endif


