
#include <iostream>
using namespace std;

#ifndef SEGMENT_H
#define SEGMENT_H

class segment
{
	private:
		double lx, ly, rx, ry;

	public:
		
		segment( double llxx, double llyy, double rrxx, double rryy ):
		lx( llxx ), ly( llyy ), rx( rrxx ), ry( rryy )
		{
			double tmpX, tmpY;
			if( rx < lx || ( rx == lx && ry < ly ) )
			{
				tmpX = lx;
				tmpY = ly;
				lx = rx;
				ly = ry;
				rx = tmpX;
				ry = tmpY;
			}
		}
		
		double getLX( ){ return lx; }
		double getLY( ){ return ly; }
		double getRX( ){ return rx; }
		double getRY( ){ return ry; }
		friend ostream& operator<< ( ostream &, segment & );
};


ostream& operator<< ( ostream & out, segment & seg )
{
	out<< seg.lx << " " << seg.ly << " " << seg.rx << " " << seg.ry;
	return out;
}


#endif

