

// drawing colors
#define COLOR_GREEN 1
#define COLOR_BLUE 2
#define COLOR_RED 3

// window and ortho sizes
#define INIT_WIN_X_POS 100
#define INIT_WIN_Y_POS 100
#define MENUWIDTH 80
#define INIT_WORKSPACE_WIN_WIDTH 600
#define INIT_WIN_HEIGHT 600
#define INIT_ORTHO_X_MIN 0
#define INIT_ORTHO_X_MAX 100
#define INIT_ORTHO_Y_MIN 0
#define INIT_ORTHO_Y_MAX 100
#define INIT_ZOOM_FACTOR 1


// button sizes
#define BUTTON_WIDTH 100
#define BUTTON_HEIGHT 5

//button codes:
#define NO_ACTION 0
#define SELECT_GREEN_BUTTON 1
#define SELECT_BLUE_BUTTON 2
#define INSERT_POINT_BUTTON 3
#define REMOVE_POINT_BUTTON 4
#define ZOOM_IN_BUTTON 5
#define ZOOM_OUT_BUTTON 6
#define MOVE_VIEW_BUTTON 9
#define QUIT_BUTTON 7
#define SHOW_MOUSE_COORDS_BUTTON 8
#define LOAD_POINT_BUTTON 10
#define LOAD_LINE_BUTTON 11
#define LOAD_REGION_BUTTON 12
#define INTERSECTION_BUTTON 13
#define UNION_BUTTON 14
#define DIFFERENCE_BUTTON 15
#define MIN_DISTANCE_BUTTON 16
#define CLEAR_OPERATION_BUTTON 17
#define INSERT_BLOCK_BUTTON 18
#define REMOVE_BLOCK_BUTTON 19
#define INSERT_FACE_BUTTON 20
#define REMOVE_FACE_BUTTON 21
#define INSERT_HOLE_BUTTON 22
#define REMOVE_HOLE_BUTTON 23
#define VALIDATE_BUTTON 24
#define AREA_OPERATION_BUTTON 25
#define LENGTH_OPERATION_BUTTON 26

#define CONVEX_HULL_BUTTON 27
#define DELAUNAY_TRIANGULATION_BUTTON 28
#define VORONOI_BUTTON 29

