#include "point2D.h"
#include "line2D.h"
#include "region2D.h"
#include <iostream>
#include <sstream>
#include <stdlib.h>
#include "mSlob.h"
#include <oci.h>
#include "TopPred2D.h"
//#include "statusHseg2D.h"
//#include "SweepLine.h"
using namespace stu;

typedef struct OCILobWrapper{
	OCILobLocator* lob;
	OCISvcCtx*	cntxt;
	OCIError* errhp;
} OCILobWrapper;

static text *username = (text *) "rpraing";
static text *password = (text *) "mypass";

static OCIEnv *envhp;
static OCIError *errhp;
static sword status;

static void checkerr(OCIError *errhp, sword status)
{
	text errbuf[512];
	//ub4 buflen;
	sb4 errcode;
	string er;
	
	if (status == OCI_SUCCESS) return;

	switch (status)
	{
		case OCI_SUCCESS_WITH_INFO:
			cout << "Error - OCI_SUCCESS_WITH_INFO" << endl;
			OCIErrorGet ((dvoid *) errhp, (ub4) 1, (text *) NULL, &errcode,
						  errbuf, (ub4) sizeof(errbuf), (ub4) OCI_HTYPE_ERROR);
			er=(char*)errbuf;
			cout << "Error -" << er << endl;
			break;
		case OCI_NEED_DATA:
			cout << "Error - OCI_NEED_DATA" << endl;
			break;
		case OCI_NO_DATA:
			cout << "Error - OCI_NO_DATA" << endl;
			break;
		case OCI_ERROR:
			OCIErrorGet ((dvoid *) errhp, (ub4) 1, (text *) NULL, &errcode,
						  errbuf, (ub4) sizeof(errbuf), (ub4) OCI_HTYPE_ERROR);
			er=(char*)errbuf;
			cout << "Error -" << er << endl;
			break;
		case OCI_INVALID_HANDLE:
			cout << "Error - OCI_INVALID_HANDLE" << endl;
			break;
		case OCI_STILL_EXECUTING:
			cout << "Error - OCI_STILL_EXECUTING" << endl;
			break;
		case OCI_CONTINUE:
			cout << "Error - OCI_CONTINUE" << endl;
			break;
		default:
			cout << "Error - " << status << endl;
			break;
	}
}

string itoa(int n)
{
	stringstream converter;
	converter << n;
	return converter.str();
}

int main ()
{

	Locator slobby;
	OCILobLocator *mylob, *mylob2;
	uint did, did2;
	string option;
	
	//cout << "Test: " << sizeof(uint) << endl;
	
	OCISession *authp = (OCISession *) 0;
	OCIServer *srvhp;
	OCISvcCtx *svchp;
	OCIStmt	*stmthp;
	OCIStmt	*stmthp2;
	OCIDefine *defnp = (OCIDefine *) 0;
	OCIDefine *defnp2 = (OCIDefine *) 0;
	OCIDefine *defnp3 = (OCIDefine *) 0;
	OCIDefine *defnp4 = (OCIDefine *) 0;
			
	try{

		
		cout << "creating connection...";
		
/*		OCISession *authp = (OCISession *) 0;
		OCIServer *srvhp;
		OCISvcCtx *svchp;
		OCIStmt	*stmthp;
		OCIDefine *defnp = (OCIDefine *) 0;
		OCIDefine *defnp2 = (OCIDefine *) 0;*/
	
	//create environment and 	//allocate handles and data structures
		(void) OCIInitialize((ub4) OCI_DEFAULT, (dvoid *)0,
		(dvoid * (*)(dvoid *, size_t)) 0,
		(dvoid * (*)(dvoid *, dvoid *, size_t))0,
		(void (*)(dvoid *, dvoid *)) 0 );

		(void) OCIEnvInit( (OCIEnv **) &envhp, OCI_DEFAULT, (size_t) 0,
		(dvoid **) 0 );

		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &errhp, OCI_HTYPE_ERROR,
		(size_t) 0, (dvoid **) 0);

		/* server contexts */
		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &srvhp, OCI_HTYPE_SERVER,
		(size_t) 0, (dvoid **) 0);

		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &svchp, OCI_HTYPE_SVCCTX,
		(size_t) 0, (dvoid **) 0);

		(void) OCIServerAttach( srvhp, errhp, (text *)"berlin.dbcenter.cise.ufl.edu:1521/orastu1", strlen("berlin.dbcenter.cise.ufl.edu:1521/orastu1"), 0);

		/* set attribute server context in the service context */
		(void) OCIAttrSet( (dvoid *) svchp, OCI_HTYPE_SVCCTX, (dvoid *)srvhp,
		(ub4) 0, OCI_ATTR_SERVER, (OCIError *) errhp);

		(void) OCIHandleAlloc((dvoid *) envhp, (dvoid **)&authp,
		(ub4) OCI_HTYPE_SESSION, (size_t) 0, (dvoid **) 0);

		(void) OCIAttrSet((dvoid *) authp, (ub4) OCI_HTYPE_SESSION,
		(dvoid *) username, (ub4) strlen((char *)username),
		(ub4) OCI_ATTR_USERNAME, errhp);

		(void) OCIAttrSet((dvoid *) authp, (ub4) OCI_HTYPE_SESSION,
		(dvoid *) password, (ub4) strlen((char *)password),
		(ub4) OCI_ATTR_PASSWORD, errhp);

	//connect to server and being session
		checkerr(errhp, OCISessionBegin ( svchp,  errhp, authp, OCI_CRED_RDBMS,
				 (ub4) OCI_DEFAULT));

		(void) OCIAttrSet((dvoid *) svchp, (ub4) OCI_HTYPE_SVCCTX,
		(dvoid *) authp, (ub4) 0,
		(ub4) OCI_ATTR_SESSION, errhp);
		
		cout << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\bConnection created succesfully!" << endl;
			
		bool quit=false;
		
		while (!quit){
			cout << "My snazzy MENU:\n(r): Read an object\n(w): Write an object\n(d): Determine a relationship between two existing objects\n(v): Verify a relationship between two existing objects\n(a) Auto-verify all relationships for a specific type combination\n(quit): Yeah quit, Duh!\nChoose one: ";
			cin >> option;
		
			if (option=="r"){ //then select data and read
				
				string id;
				string type;
				cout << "1: point2D\n2: line2D\n3: region2D\n";
				cout << "Please select the type of object to be read: ";
				cin >> type;
				cout << "Please give me the id of the object to be retrieved: ";
				cin >> id;
				
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
				
				//allocate lob descriptor
				if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
					(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
				{
					cout << "FAILED: OCIDescriptorAlloc()" << endl;
					return OCI_ERROR;
				}
				
				string sqlQuery = "SELECT id,data FROM mymslob where id=" + id;// + " FOR UPDATE";
				
					//issue SQL and process data
				checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
						 (ub4)strlen(sqlQuery.c_str()),
						 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
	
	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
						 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
						 (ub2 *)0, OCI_DEFAULT));

	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
						 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
						 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
				/* execute and fetch */
				if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
				{
					if (status == OCI_NO_DATA)
						cout << "No data returned!" << endl;
					else
					{
						checkerr(errhp, status);
						if (envhp)
							(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
						return OCI_ERROR;
					}
				}//else success then processs

				if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
				{
					
					//cout << "The COUNT: " << points_getCount(blob1) << endl;
					
					OCILobWrapper *blob1=new OCILobWrapper;
					blob1->lob=mylob;
					blob1->cntxt=svchp;
					blob1->errhp=errhp;
					
					mSlob p(blob1);
					Locator daddy(p.locateGlobal());
					Locator obj(daddy.locate(0));
					cout << "Global: "; obj.debug();
					if(type=="1")
					{
						cout << "mSLOB Built from point with id " << did << endl;
						point2D ps(obj);
						cout << "The point: " << ps << endl;
					}
					else if(type == "2")
					{
						cout << "mSLOB Built from line with id " << did << endl;
						line2D ps(obj);
						cout << "The halfsegments: " << ps << endl;
						cout << "By Blocks..." << endl;
						for (uint i=0; i<ps.getBlockCount(); i++){
							cout << "Block " << (i+1) << ": " << ps.getBlock(i) << endl;
						}
					}
					else if(type == "3")
					{
						cout << "mSLOB Built from region with id " << did << endl;
						region2D ps(obj);
						cout << "The halfsegments: " << ps << endl;
						cout << "By Faces..." << endl;
						for (uint i=0; i<ps.getFaceCount(); i++){
							cout << "Face " << (i+1) << ": " << ps.getFace(i) << endl;
						}
					}
					
					checkerr(errhp, OCILobClose(svchp, errhp, mylob));
					delete blob1;
					blob1 = NULL;
	
				}else
					cout << "No object with id=" << id << " found." << endl;
					
					//free the statement handle	
					checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
			}else if (option=="w"){ //create a new point
				string id;
				uint did;
				string type;
				cout << "1: point2D\n2: line2D\n3: region2D\n";
				cout << "Please select the type of object to be written: ";
				cin >> type;
				cout << "Please give me the id of the object to be written: ";
				cin >> id;
				
				mylob=NULL;
				
				while (true){
					checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
							 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
					
					//allocate lob descriptor
					if (mylob==NULL){
						if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
							(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
						{
							cout << "FAILED: OCIDescriptorAlloc()" << endl;
							return OCI_ERROR;
						}
					}
					
					string sqlQuery = "SELECT id,data FROM mymslob where id=" + id + " FOR UPDATE";
					
						//issue SQL and process data
					checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
							 (ub4)strlen(sqlQuery.c_str()),
							 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
					checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
							 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
							 (ub2 *)0, OCI_DEFAULT));
	
					checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
							 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
							 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
					
					/* execute and fetch */
					if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
						(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
					{
						if (status == OCI_NO_DATA){
							cout << "No data returned, so lets create the tuple." << endl;
							
							//checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
							
							//checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
							//		OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
							
							sqlQuery = "insert into mymslob values( " + id + ", EMPTY_BLOB())";
							
							checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
									 (ub4)strlen(sqlQuery.c_str()),
									 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	

							checkerr(errhp, OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
									 (CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT));
							cout << "Inserted new tuple with empty blob and id " << id << endl;
							
							if (stmthp)
								checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
/*							checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
							checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));*/
						}
						else
						{
							checkerr(errhp, status);
							if (envhp)
								(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
							return OCI_ERROR;
						}
					}else break;//success retrieving then processs
				}
				cout << "Tuple Retrieved Succesfully!" << endl;
				
				if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
				{
					OCILobWrapper *blob1=new OCILobWrapper;
					blob1->lob=mylob;
					blob1->cntxt=svchp;
					blob1->errhp=errhp;
					
					mSlob p(blob1);
					
					Locator daddy(p.locateGlobal());
					if (daddy.getElements()==0) //then build an object node
						daddy.insert(0,OBJECT_LEVEL);
					
					Locator obj(daddy.locate(0));
					
					cout << "Global created: "; obj.debug();
					if(type=="1")
					{
						point2D ps(obj);
						cout << "Point with ID: " << did << " ready for update..." << endl;
						bool quit2=false;
						while (!quit2){
							cout << "Do you want to add (a) or remove (r) a point from this object? (q when done) ";
							cin >> option;
							cin.ignore(1);
							if (option=="a"){
								rational x,y;
								cout << "Give me 'x': ";
								cin >> x;
								cout << "Give me 'y': ";
								cin >> y;
								poi2D* np=new poi2D(x,y);
								cout << "Built pointy: " << *np << endl;
								ps.addPoint(*np);	
							}else if (option=="r"){
								rational x,y;
								cout << "Give me 'x': ";
								cin >> x;
								cout << "Give me 'y': ";
								cin >> y;
								poi2D* np=new poi2D(x,y);
								cout << "Built pointy: " << *np << endl;
								ps.removePoint(*np);						
							}else if (option=="q"){
								quit2=true;
							}
						}
					}
					else if(type == "2")
					{
						obj.beginBatch();
						line2D ps(obj);
						cout << "Line with ID: " << did << " ready for update..." << endl;
				
						bool quit2=false;
						while (!quit2){
							cout << "Do you want to add (a) or remove (r) a block from this object? (q when done) ";
							cin >> option;
							if (option=="a"){
								block2D bl=ps.addBlock();	
								cout << "Added empty block, will add segments to it now." << endl;
								while (option!="n"){
									cin.ignore(1);
									rational px,py,qx,qy;
									cout << "Enter x for p of this segment:";
									cin >> px;
									cout << "Enter y for p of this segment:";
									cin >> py;
									cout << "Enter x for q of this segment:";
									cin >> qx;
									cout << "Enter y for q of this segment:";
									cin >> qy;
									poi2D np(px,py);
									poi2D nq(qx,qy);
									seg2D ns(np,nq);						
									cout << "Built segment: " << ns << endl;
									bl.addSegment(ns);
									cout << "Added segment...Want to add another one? (y/n)" << endl;
									cin >> option;
								}
								//bl.finalize();
							}else if (option=="r"){
								uint idblk;
								cin.ignore(1);
								cout << "Line " << did << " has  " << ps.getBlockCount() << " blocks. Which one do you want to remove?" << endl;
								cin >> idblk;
								ps.removeBlock(idblk);
								cout << "Block removed." << endl;
							}else if (option=="q"){
								cin.ignore(1);
								quit2=true;
							}
							ps.validate();
						//p.commitBatch();
						}
						obj.commitBatch();
					}
					else if(type == "3")
					{
						obj.beginBatch();
						region2D ps(obj);
					
						cout << "Region with ID: " << did << " ready for update..." << endl;
				
						bool quit2=false;
						while (!quit2){
							cout << "Do you want to add (a) or remove (r) a face from this object? (q when done) ";
							cin >> option;
							if (option=="a"){
								face2D f1=ps.addFace();
								poly2D p1=f1.addOuterCycle();
								cout << "Added face and empty outer cycle, will add outer cycle segments now:" << endl;
								while (option!="n"){
									cin.ignore(1);
									rational px,py,qx,qy;
									cout << "Enter x for p of this segment:";
									cin >> px;
									cout << "Enter y for p of this segment:";
									cin >> py;
									cout << "Enter x for q of this segment:";
									cin >> qx;
									cout << "Enter y for q of this segment:";
									cin >> qy;
									poi2D np(px,py);
									poi2D nq(qx,qy);
									seg2D ns(np,nq);						
									cout << "Built segment: " << ns << endl;
									p1.addSegment(ns);
									cout << "Added segment...Want to add another one? (y/n)" << endl;
									cin >> option;
								}
								//p1.finalize(); //finalize outer cycle
								while (true)
								{
									cout << "Do you want to add a hole to the face? (y/n)" << endl;
									cin >> option;
									if (option=="n"){
										cin.ignore(1);
										break; //get out of the while true
									}
									if (option=="y"){
										poly2D hole=f1.addHole();
										while (option!="n"){
										cin.ignore(1);
										cout << "Alright adding segments to the hole..." << endl;
										rational px,py,qx,qy;
										cout << "Enter x for p of this segment:";
										cin >> px;
										cout << "Enter y for p of this segment:";
										cin >> py;
										cout << "Enter x for q of this segment:";
										cin >> qx;
										cout << "Enter y for q of this segment:";
										cin >> qy;
										poi2D np(px,py);
										poi2D nq(qx,qy);
										seg2D ns(np,nq);						
										cout << "Built segment for hole: " << ns << endl;
										hole.addSegment(ns);
										cout << "Added segment...Want to add another one? (y/n)" << endl;
										cin >> option;
										}
									//	hole.finalize(); //finalize hole
									}
								}
							//	f1.finalize();
							}else if (option=="r"){
								uint idface;
								cin.ignore(1);
								cout << "Region " << did << " has  " << ps.getFaceCount() << " faces. Which one do you want to remove?" << endl;
								cin >> idface;
								ps.removeFace(idface);
								cout << "Face removed." << endl;
							}else if (option=="q"){
								cin.ignore(1);
								quit2=true;
							}
							ps.validate();
						//p.commitBatch();
						}
						obj.commitBatch();	
					}
					checkerr(errhp, OCILobClose(svchp, errhp, mylob));
					checkerr(errhp, OCITransCommit(svchp, errhp, (ub4)0));
					delete blob1;
				}else
					cerr << "Problem retrieving newly created tuple" << endl;				

					checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
			}else if (option=="d" || option=="v"){ //then select data and read
				
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp2,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));					
					
				if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
					(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
				{
					cout << "FAILED: OCIDescriptorAlloc() 1" << endl;
					return OCI_ERROR;
				}
				
				string id1, id2, pid;
				string type;
				cout << "1: point2D x point2D\n2: point2D x line2D\n3: point2D x region2D\n4: line2D x line2D\n5: line2D x region2D\n6: region2D x region2D\n";
				cout << "Please select the type combination: ";
				cin >> type;
				cout << "Please give me the id of the first object: ";
				cin >> id1;
				
				cout << "Please give me the id of the second object: ";
				cin >> id2;
				
				if(option=="v")
				{
					cout << "Please give me the predicate id to be verified: ";
					cin >> pid;
				}
				
				string sqlQuery = "SELECT id,data FROM mymslob where id=" + id1;
				string sqlQuery2 = "SELECT id,data FROM mymslob where id=" + id2;

				
				//issue first SQL and process data
				checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
						 (ub4)strlen(sqlQuery.c_str()),
						 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
						 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
						 (ub2 *)0, OCI_DEFAULT));
	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
						 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
						 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
				if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
				{
					if (status == OCI_NO_DATA){
						cout << "First tuple not found!" << endl;
						break;
					}
					else
					{
						checkerr(errhp, status);
						if (envhp)
							(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
						return OCI_ERROR;
					}
				}else  //first tuple found, find the second now
					cout << "First tuple found! " << did << endl;
				
					if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob2,
						(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
					{
						cout << "FAILED: OCIDescriptorAlloc() 2" << endl;
						return OCI_ERROR;
					}
						
				//issue first SQL and process data
					checkerr(errhp, OCIStmtPrepare(stmthp2, errhp, (text *)(sqlQuery2.c_str()),
							 (ub4)strlen(sqlQuery2.c_str()),
							 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
					checkerr(errhp, OCIDefineByPos(stmthp2, &defnp3, errhp, 1, (dvoid *) &did2,
							 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
							 (ub2 *)0, OCI_DEFAULT));
	
					checkerr(errhp, OCIDefineByPos(stmthp2, &defnp4, errhp, (ub4) 2,
							 (dvoid *) &mylob2, (sb4) -1, (ub2) SQLT_BLOB,
							 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
					if (status = OCIStmtExecute(svchp, stmthp2, errhp, (ub4) 1, (ub4) 0,
						(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
					{
						if (status == OCI_NO_DATA){
							cout << "Second tuple not found!" << endl;
							break;
						}
						else
						{
							checkerr(errhp, status);
							if (envhp)
								(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
							return OCI_ERROR;
						}
					}else // second tuple found, success
						cout << "Second tuple found! " << did2 << endl;
				
						cout << "Tuples Found!, success?" << endl;
				
						if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
						{
							OCILobWrapper *blob1=new OCILobWrapper;
							OCILobWrapper *blob2=new OCILobWrapper;
				
							oraub8 blength=0;
							checkerr(errhp, OCILobGetLength2(svchp, errhp, mylob, &blength));
							cout << "Length of 1: " << blength << endl;
				
							checkerr(errhp, OCILobGetLength2(svchp, errhp, mylob2, &blength));
							cout << "Length of 2: " << blength << endl;
							
							
							blob1->lob=mylob;
							blob1->cntxt=svchp;
							blob1->errhp=errhp;
					
							blob2->lob=mylob2;
							blob2->cntxt=svchp;
							blob2->errhp=errhp;
							
							mSlob obj1(blob1);
							cout << "Built object 1" << endl;
							mSlob obj2(blob2);
							cout << "Built object 2" << endl;
							cout << "mSLOBs Built from objects" << endl;
					
							Locator daddy1(obj1.locateGlobal());
							Locator o1(daddy1.locate(0));
					
							Locator daddy2(obj2.locateGlobal());
							Locator o2(daddy2.locate(0));
							
							if(type=="1")
							{
								point2D ps1(o1);
								point2D ps2(o2);
					
								cout << "The points and the result: " << endl;
								cout << "P1: " << ps1 << endl;
								cout << "P2: " << ps2 << endl;

								if (option=="d") cout << "The topological relationship id between P1 and P2 is: " << TopPred2D::topPred(ps1,ps2) <<endl;
								if (option=="v") cout << "Is it the case that the topological relationship id between P1 and P2 is "<< pid << ": " << TopPred2D::topPred(ps1,ps2,atoi(pid.c_str())) << endl;

							}
							else if(type == "2")
							{
								point2D ps1(o1);
								line2D ps2(o2);
								cout << "The point: " << ps1 << endl;
								cout << "The line (by halfsegments): " << ps2 << endl;
								cout << "The line (by blocks): " << endl;
								for (uint i=0; i<ps2.getBlockCount(); i++){
									cout << "Block " << (i+1) << ": " << ps2.getBlock(i) << endl;
								}
								if (option=="d") cout << "The topological relationship id between the two objects is: " << TopPred2D::topPred(ps1,ps2) <<endl;
								if (option=="v") cout << "Is it the case that the topological relationship id between the two objects is "<< pid << ": " << TopPred2D::topPred(ps1,ps2,atoi(pid.c_str())) << endl;
							}
							else if(type == "3")
							{
								point2D ps1(o1);
								region2D ps2(o2);
								cout << "The point: " << ps1 << endl;
								cout << "The region (by halfsegments): " << ps2 << endl;
								cout << "The region (by faces): " << endl;
								for (uint i=0; i<ps2.getFaceCount(); i++){
									cout << "Face " << (i+1) << ": " << ps2.getFace(i) << endl;
								}
								if (option=="d") cout << "The topological relationship id between the two objects is: " << TopPred2D::topPred(ps1,ps2) <<endl;
								if (option=="v") cout << "Is it the case that the topological relationship id between the two objects is "<< pid << ": " << TopPred2D::topPred(ps1,ps2,atoi(pid.c_str())) << endl;
							}
							else if(type == "4")
							{
								line2D ps1(o1);
								line2D ps2(o2);
								cout << "Line1 (by halfsegments): " << ps1 << endl;
								cout << "Line1 (by blocks): " << endl;
								for (uint i=0; i<ps1.getBlockCount(); i++){
									cout << "Block " << (i+1) << ": " << ps1.getBlock(i) << endl;
								}
								cout << "Line2 (by halfsegments): " << ps2 << endl;
								cout << "Line2 (by blocks): " << endl;
								for (uint i=0; i<ps2.getBlockCount(); i++){
									cout << "Block " << (i+1) << ": " << ps2.getBlock(i) << endl;
								}
								if (option=="d") cout << "The topological relationship id between the two objects is: " << TopPred2D::topPred(ps1,ps2) <<endl;
								if (option=="v") cout << "Is it the case that the topological relationship id between the two objects is "<< pid << ": " << TopPred2D::topPred(ps1,ps2,atoi(pid.c_str())) << endl;
							}
							else if(type == "5")
							{
								line2D ps1(o1);
								region2D ps2(o2);
								cout << "The line (by halfsegments): " << ps1 << endl;
								cout << "The line (by blocks): " << endl;
								for (uint i=0; i<ps1.getBlockCount(); i++){
									cout << "Block " << (i+1) << ": " << ps1.getBlock(i) << endl;
								}
								cout << "The region (by halfsegments): " << ps2 << endl;
								cout << "The region (by faces): " << endl;
								for (uint i=0; i<ps2.getFaceCount(); i++){
									cout << "Face " << (i+1) << ": " << ps2.getFace(i) << endl;
								}
								if (option=="d") cout << "The topological relationship id between the two objects is: " << TopPred2D::topPred(ps1,ps2) <<endl;
								if (option=="v") cout << "Is it the case that the topological relationship id between the two objects is "<< pid << ": " << TopPred2D::topPred(ps1,ps2,atoi(pid.c_str())) << endl;
							}
							else if(type == "6")
							{
								region2D ps1(o1);
								region2D ps2(o2);
								cout << "The region1 (by halfsegments): " << ps1 << endl;
								cout << "The region1 (by faces): " << endl;
								for (uint i=0; i<ps1.getFaceCount(); i++){
									cout << "Face " << (i+1) << ": " << ps1.getFace(i) << endl;
								}
								cout << "The region2 (by halfsegments): " << ps2 << endl;
								cout << "The region2 (by faces): " << endl;
								for (uint i=0; i<ps2.getFaceCount(); i++){
									cout << "Face " << (i+1) << ": " << ps2.getFace(i) << endl;
								}
								if (option=="d") cout << "The topological relationship id between the two objects is: " << TopPred2D::topPred(ps1,ps2) <<endl;
								if (option=="v") cout << "Is it the case that the topological relationship id between the two objects is "<< pid << ": " << TopPred2D::topPred(ps1,ps2,atoi(pid.c_str())) << endl;
							}
							
							checkerr(errhp, OCILobClose(svchp, errhp, mylob));
							delete blob1;
							checkerr(errhp, OCILobClose(svchp, errhp, mylob2));
							delete blob2;
						}else{
							cout << "One of the objects was not found!" << endl;
						}
						checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
						checkerr(errhp, OCIHandleFree(stmthp2,OCI_HTYPE_STMT));
/*						exit(1);*/
			}
			else if(option == "a")
			{
				string type;
				cout << "1: point2D x point2D\n2: point2D x line2D\n3: point2D x region2D\n4: line2D x line2D\n5: line2D x region2D\n6: region2D x region2D\n";
				cout << "Please select the type combination: ";
				cin >> type;
				int cnt = 0, id1=0, id2=0;
				bool seq = false;
				if(type=="1")
				{
					cnt = 5;
					id1 = 1000;
					id2 = 1000;
					seq = true;
				}
				else if(type=="2")
				{
					cnt = 14;
					id1 = 2000;
					id2 = 2500;
				}
				else if(type=="3")
				{
					cnt = 7;
					id1 = 3000;
					id2 = 3500;
				}
				else if(type=="4")
				{
					cnt = 82;
					id1 = 4000;
					id2 = 4000;
					seq = true;
				}
				else if(type=="5")
				{
					cnt = 43;
					id1 = 5000;
					id2 = 5500;
				}
				else if(type=="6")
				{
					cnt = 33;
					id1 = 6000;
					id2 = 6000;
					seq = true;
				}
				
				for(int i = 1; i<=cnt; i++)
				{
					checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
							OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
					checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp2,
							OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));					
				
					if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
							(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
					{
						cout << "FAILED: OCIDescriptorAlloc() 1" << endl;
						return OCI_ERROR;
					}
					string xid1, xid2;
					if(seq)
					{
						xid1 = itoa(id1 + i*2 -1);
						xid2 = itoa(id2 + i*2);
					}
					else
					{
						xid1 = itoa(id1 + i);
						xid2 = itoa(id2 + i);
					}
					string sqlQuery = "SELECT id,data FROM mymslob where id=" + xid1;
					string sqlQuery2 = "SELECT id,data FROM mymslob where id=" + xid2;
					//issue first SQL and process data
					checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
							(ub4)strlen(sqlQuery.c_str()),
							(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
					checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
							(sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
							(ub2 *)0, OCI_DEFAULT));
	
					checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
							(dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
							(dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
					if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					    (CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
					{
						if (status == OCI_NO_DATA){
							cout << "First tuple not found!" << endl;
							break;
						}
						else
						{
							checkerr(errhp, status);
							if (envhp)
								(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
							return OCI_ERROR;
						}
					}//else  //first tuple found, find the second now
					//	cout << "First tuple found! " << did << endl;
				
					if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob2,
							(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
					{
						cout << "FAILED: OCIDescriptorAlloc() 2" << endl;
						return OCI_ERROR;
					}
					
					//issue first SQL and process data
					checkerr(errhp, OCIStmtPrepare(stmthp2, errhp, (text *)(sqlQuery2.c_str()),
							(ub4)strlen(sqlQuery2.c_str()),
							(ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
	
					checkerr(errhp, OCIDefineByPos(stmthp2, &defnp3, errhp, 1, (dvoid *) &did2,
							(sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
							(ub2 *)0, OCI_DEFAULT));

					checkerr(errhp, OCIDefineByPos(stmthp2, &defnp4, errhp, (ub4) 2,
							(dvoid *) &mylob2, (sb4) -1, (ub2) SQLT_BLOB,
							(dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
			
					if (status = OCIStmtExecute(svchp, stmthp2, errhp, (ub4) 1, (ub4) 0,
							(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
					{
						if (status == OCI_NO_DATA){
							cout << "Second tuple not found!" << endl;
							break;
						}
						else
						{
							checkerr(errhp, status);
							if (envhp)
								(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
							return OCI_ERROR;
						}
					}
					//else // second tuple found, success
					//	cout << "Second tuple found! " << did2 << endl;
			
					//	cout << "Tuples Found!, success?" << endl;
			
					if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
					{
						OCILobWrapper *blob1=new OCILobWrapper;
						OCILobWrapper *blob2=new OCILobWrapper;
		
						oraub8 blength=0;
						checkerr(errhp, OCILobGetLength2(svchp, errhp, mylob, &blength));
						//cout << "Length of 1: " << blength << endl;
		
						checkerr(errhp, OCILobGetLength2(svchp, errhp, mylob2, &blength));
						//cout << "Length of 2: " << blength << endl;
					
					
						blob1->lob=mylob;
						blob1->cntxt=svchp;
						blob1->errhp=errhp;
			
						blob2->lob=mylob2;
						blob2->cntxt=svchp;
						blob2->errhp=errhp;
					
						mSlob obj1(blob1);
						//cout << "Built object 1" << endl;
						mSlob obj2(blob2);
						//cout << "Built object 2" << endl;
						//cout << "mSLOBs Built from objects" << endl;
			
						Locator daddy1(obj1.locateGlobal());
						Locator o1(daddy1.locate(0));
			
						Locator daddy2(obj2.locateGlobal());
						Locator o2(daddy2.locate(0));
					
						if(type=="1")
						{
							point2D ps1(o1);
							point2D ps2(o2);
							cout<<"Verifying object "<< xid1 << " and "<<xid2<<" for predicate "<<i<<" : ";
							if (TopPred2D::topPred(ps1,ps2,i)) cout << "VERIFIED!"<<endl;
							else cout << "*****ERROR*****!" << TopPred2D::topPred(ps1,ps2)<<endl;
						}
						if(type=="2")
						{
							point2D ps1(o1);
							line2D ps2(o2);
							cout<<"Verifying object "<< xid1 << " and "<<xid2<<" for predicate "<<i<<" : ";
							if (TopPred2D::topPred(ps1,ps2,i)) cout << "VERIFIED!"<<endl;
							else cout << "*****ERROR*****!" <<TopPred2D::topPred(ps1,ps2)<<endl;
						}
						if(type=="3")
						{
							point2D ps1(o1);
							region2D ps2(o2);
							cout<<"Verifying object "<< xid1 << " and "<<xid2<<" for predicate "<<i<<" : ";
							if (TopPred2D::topPred(ps1,ps2,i)) cout << "VERIFIED!"<<endl;
							else cout << "*****ERROR*****!" <<TopPred2D::topPred(ps1,ps2)<<endl;
						}
						if(type=="4")
						{
							line2D ps1(o1);
							line2D ps2(o2);
							cout<<"Verifying object "<< xid1 << " and "<<xid2<<" for predicate "<<i<<" : ";
							if (TopPred2D::topPred(ps1,ps2,i)) cout << "VERIFIED!"<<endl;
							else cout << "*****ERROR*****!" <<TopPred2D::topPred(ps1,ps2)<<endl;
						}
						if(type=="5")
						{
							line2D ps1(o1);
							region2D ps2(o2);
							cout<<"Verifying object "<< xid1 << " and "<<xid2<<" for predicate "<<i<<" : ";
							if (TopPred2D::topPred(ps1,ps2,i)) cout << "VERIFIED!"<<endl;
							else cout << "*****ERROR*****!" <<TopPred2D::topPred(ps1,ps2)<<endl;
						}
						if(type=="6")
						{
							region2D ps1(o1);
							region2D ps2(o2);
							cout<<"Verifying object "<< xid1 << " and "<<xid2<<" for predicate "<<i<<" : ";
							if (TopPred2D::topPred(ps1,ps2,i)) cout << "VERIFIED!"<<endl;
							else cout << "*****ERROR*****!" <<TopPred2D::topPred(ps1,ps2)<<endl;
						}
						checkerr(errhp, OCILobClose(svchp, errhp, mylob));
						delete blob1;
						checkerr(errhp, OCILobClose(svchp, errhp, mylob2));
						delete blob2;
					}else{
						cout << "One of the objects was not found!" << endl;
					}
					checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
					checkerr(errhp, OCIHandleFree(stmthp2,OCI_HTYPE_STMT));
				}
			}else{ 
				if (option=="quit")
					quit=true;
			}
		}
		
		cout << "Thanks for testing with us!!!" << endl;
		cout << "Closing connection" << endl;
		if (srvhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SERVER);
		if (svchp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SVCCTX);
		if (errhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_ERROR);
		if (envhp)
			(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
	}
	catch (exception &excp)
	{
		cerr << excp.what() << endl;
		cout << "Thanks...sorry we ended this on such a bad note." << endl;
		cout << "Closing connection" << endl;
		
		if (srvhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SERVER);
		if (svchp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SVCCTX);
		if (errhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_ERROR);
		if (envhp)
			(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
	}
}


