#include "region2D.h"
#include "line2D.h"
#include <iostream>
#include "mSlob.h"
#include <oci.h>
//#include "EventSchedule.h"
//#include "statusHseg2D.h"
//#include "SweepLine.h"
using namespace stu;

typedef struct OCILobWrapper{
	OCILobLocator* lob;
	OCISvcCtx*	cntxt;
	OCIError* errhp;
} OCILobWrapper;

static text *username = (text *) "apauly";
static text *password = (text *) "testis";

static OCIEnv *envhp;
static OCIError *errhp;
static sword status;

static void checkerr(OCIError *errhp, sword status)
{
	text errbuf[512];
	//ub4 buflen;
	sb4 errcode;
	string er;
	
	if (status == OCI_SUCCESS) return;

	switch (status)
	{
		case OCI_SUCCESS_WITH_INFO:
			cout << "Error - OCI_SUCCESS_WITH_INFO" << endl;
			OCIErrorGet ((dvoid *) errhp, (ub4) 1, (text *) NULL, &errcode,
						  errbuf, (ub4) sizeof(errbuf), (ub4) OCI_HTYPE_ERROR);
			er=(char*)errbuf;
			cout << "Error -" << er << endl;
			break;
		case OCI_NEED_DATA:
			cout << "Error - OCI_NEED_DATA" << endl;
			break;
		case OCI_NO_DATA:
			cout << "Error - OCI_NO_DATA" << endl;
			break;
		case OCI_ERROR:
			OCIErrorGet ((dvoid *) errhp, (ub4) 1, (text *) NULL, &errcode,
						  errbuf, (ub4) sizeof(errbuf), (ub4) OCI_HTYPE_ERROR);
			er=(char*)errbuf;
			cout << "Error -" << er << endl;
			break;
		case OCI_INVALID_HANDLE:
			cout << "Error - OCI_INVALID_HANDLE" << endl;
			break;
		case OCI_STILL_EXECUTING:
			cout << "Error - OCI_STILL_EXECUTING" << endl;
			break;
		case OCI_CONTINUE:
			cout << "Error - OCI_CONTINUE" << endl;
			break;
		default:
			cout << "Error - " << status << endl;
			break;
	}
}


int main ()
{

	Locator slobby(false);
	OCILobLocator *mylob, *mylob2;
	uint did, did2;
	string option;
	
	cout << "Test: " << sizeof(uint) << endl;
	
	OCISession *authp = (OCISession *) 0;
	OCIServer *srvhp;
	OCISvcCtx *svchp;
	OCIStmt	*stmthp;
	OCIStmt	*stmthp2;
	OCIDefine *defnp = (OCIDefine *) 0;
	OCIDefine *defnp2 = (OCIDefine *) 0;
	OCIDefine *defnp3 = (OCIDefine *) 0;
	OCIDefine *defnp4 = (OCIDefine *) 0;
			
// 	try{

		
		cout << "creating connection...";
		
/*		OCISession *authp = (OCISession *) 0;
		OCIServer *srvhp;
		OCISvcCtx *svchp;
		OCIStmt	*stmthp;
		OCIDefine *defnp = (OCIDefine *) 0;
		OCIDefine *defnp2 = (OCIDefine *) 0;*/
	
	//create environment and 	//allocate handles and data structures
		(void) OCIInitialize((ub4) OCI_DEFAULT, (dvoid *)0,
		(dvoid * (*)(dvoid *, size_t)) 0,
		(dvoid * (*)(dvoid *, dvoid *, size_t))0,
		(void (*)(dvoid *, dvoid *)) 0 );

		(void) OCIEnvInit( (OCIEnv **) &envhp, OCI_DEFAULT, (size_t) 0,
		(dvoid **) 0 );

		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &errhp, OCI_HTYPE_ERROR,
		(size_t) 0, (dvoid **) 0);

		/* server contexts */
		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &srvhp, OCI_HTYPE_SERVER,
		(size_t) 0, (dvoid **) 0);

		(void) OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &svchp, OCI_HTYPE_SVCCTX,
		(size_t) 0, (dvoid **) 0);

		(void) OCIServerAttach( srvhp, errhp, (text *)"berlin.dbcenter.cise.ufl.edu:1521/orastu1", strlen("berlin.dbcenter.cise.ufl.edu:1521/orastu1"), 0);

		/* set attribute server context in the service context */
		(void) OCIAttrSet( (dvoid *) svchp, OCI_HTYPE_SVCCTX, (dvoid *)srvhp,
		(ub4) 0, OCI_ATTR_SERVER, (OCIError *) errhp);

		(void) OCIHandleAlloc((dvoid *) envhp, (dvoid **)&authp,
		(ub4) OCI_HTYPE_SESSION, (size_t) 0, (dvoid **) 0);

		(void) OCIAttrSet((dvoid *) authp, (ub4) OCI_HTYPE_SESSION,
		(dvoid *) username, (ub4) strlen((char *)username),
		(ub4) OCI_ATTR_USERNAME, errhp);

		(void) OCIAttrSet((dvoid *) authp, (ub4) OCI_HTYPE_SESSION,
		(dvoid *) password, (ub4) strlen((char *)password),
		(ub4) OCI_ATTR_PASSWORD, errhp);

	//connect to server and being session
		checkerr(errhp, OCISessionBegin ( svchp,  errhp, authp, OCI_CRED_RDBMS,
				 (ub4) OCI_DEFAULT));

		(void) OCIAttrSet((dvoid *) svchp, (ub4) OCI_HTYPE_SVCCTX,
		(dvoid *) authp, (ub4) 0,
		(ub4) OCI_ATTR_SESSION, errhp);
		
		cout << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\bConnection created succesfully!" << endl;
			
		bool quit=false;
		
		while (!quit){
			cout << "You wanna read(r) or write(w) a region2D or do you want to calculate the intersection(i), union(u), difference(d), min-distance(d2),  convexhull(cv), or delaunayTriangulation(t) of two existing regions?? ('quit' if done): ";
			cin >> option;
		
			if (option=="r"){ //then select data and read
				
				string id;
				
				cout << "Please give me the id of the region to retrieve?";
				cin >> id;
				
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
				
				//allocate lob descriptor
				if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
					(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
				{
					cout << "FAILED: OCIDescriptorAlloc()" << endl;
					return OCI_ERROR;
				}
				
				string sqlQuery = "SELECT id,data FROM slobber where id=" + id;// + " FOR UPDATE";
				
					//issue SQL and process data
				checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
						 (ub4)strlen(sqlQuery.c_str()),
						 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
	
	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
						 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
						 (ub2 *)0, OCI_DEFAULT));

	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
						 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
						 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
				/* execute and fetch */
				if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
				{
					if (status == OCI_NO_DATA)
						cout << "No data returned!" << endl;
					else
					{
						checkerr(errhp, status);
						if (envhp)
							(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
						return OCI_ERROR;
					}
				}//else success then processs

				if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
				{
					
					//cout << "The COUNT: " << points_getCount(blob1) << endl;
					
					OCILobWrapper *blob1=new OCILobWrapper;
					blob1->lob=mylob;
					blob1->cntxt=svchp;
					blob1->errhp=errhp;
					
					mSlob p(blob1);
					
					cout << "mSLOB Built from region with id " << did << endl;
					
					Locator daddy(p.locateGlobal());
					Locator region(daddy.locate(0));
					//line.debug();
					region2D ps(region);
					
			
					cout << "The halfsegments: " << ps << endl;
					
					cout << "By Faces..." << endl;
					for (uint i=0; i<ps.getFaceCount(); i++){
						face2D facy=ps.getFace(i);
						cout << "Face " << (i+1) << " has " << facy.getHoleCount() << " holes: " << facy << endl;
					}
					
					cout << "The area: " << ps.getArea() << endl;
					
					checkerr(errhp, OCILobClose(svchp, errhp, mylob));
					delete blob1;
	
				}else
					cout << "No region with id=" << id << " found." << endl;
					
					//free the statement handle	
					checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
			}else if (option=="w"){ //create a new point
				string id;
				uint did;
					
				cout << "Please give me the id of the region to write to:";
				cin >> id;
				
				mylob=NULL;
				
				while (true){
					checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
							 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
					
					//allocate lob descriptor
					if (mylob==NULL){
						if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
							(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
						{
							cout << "FAILED: OCIDescriptorAlloc()" << endl;
							return OCI_ERROR;
						}
					}
					
					string sqlQuery = "SELECT id,data FROM slobber where id=" + id + " FOR UPDATE";
					
						//issue SQL and process data
					checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
							 (ub4)strlen(sqlQuery.c_str()),
							 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
					checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
							 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
							 (ub2 *)0, OCI_DEFAULT));
	
					checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
							 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
							 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
					
					/* execute and fetch */
					if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
						(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
					{
						if (status == OCI_NO_DATA){
							cout << "No data returned, so lets create the tuple." << endl;
							
							//checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
							
							//checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
							//		OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
							
							sqlQuery = "insert into slobber values( " + id + ", EMPTY_BLOB())";
							
							checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
									 (ub4)strlen(sqlQuery.c_str()),
									 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	

							checkerr(errhp, OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
									 (CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT));
							cout << "Inserted new tuple with empty blob and id " << id << endl;
							
							if (stmthp)
								checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
/*							checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));
							checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));*/
						}
						else
						{
							checkerr(errhp, status);
							if (envhp)
								(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
							return OCI_ERROR;
						}
					}else break;//success retrieving then processs
				}
				cout << "Tuple Retrieved Succesfully!" << endl;
				
				if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
				{
					OCILobWrapper *blob1=new OCILobWrapper;
					blob1->lob=mylob;
					blob1->cntxt=svchp;
					blob1->errhp=errhp;
					
					mSlob p(blob1);
					
					Locator daddy(p.locateGlobal());
					//daddy.debug();
					if (daddy.getElements()==0){ //then build an object node
						Locator temp(daddy.insert(0,OBJECT_LEVEL));
						cout << "Inserted OBJECT: "; temp.debug();
					}
					
					Locator region(daddy.locate(0));
					//line.debug();
					region.beginBatch();
					region2D ps(region);
					
					cout << "Region with ID: " << did << " ready for update..." << endl;
				
					bool quit2=false;
					while (!quit2){
						cout << "Do you want to add (a) or remove (r) a face from this object? (q when done) ";
						cin >> option;
						if (option=="a"){
							face2D f1=ps.addFace();
							//poly2D p1=f1.addOuterCycle();
							poly2D *p1=new poly2D(); //create memSlob poly
							cout << "Added face and empty outer cycle, will add outer cycle segments now:" << endl;
							while (option!="n"){
								cin.ignore(1);
								rational px,py,qx,qy;
								cout << "Enter x for p of this segment:";
								cin >> px;
								cout << "Enter y for p of this segment:";
								cin >> py;
								cout << "Enter x for q of this segment:";
								cin >> qx;
								cout << "Enter y for q of this segment:";
								cin >> qy;
								poi2D np(px,py);
								poi2D nq(qx,qy);
								seg2D ns(np,nq);						
								cout << "Built segment: " << ns << endl;
								p1->addSegment(ns);
								//p1.addSegment(ns);
								cout << "Added segment...Want to add another one? (y/n)" << endl;
								cin >> option;
							}
/*							cout << "Before Validate (outer): " << *p1 << endl;*/
/*						if (p1.validate()){ //finalize outer cycle
								cout << "After Validate (outer): " << p1 << endl;
								f1.addOuterCycle(p1);
								cout << "Added outer to face." << endl;
							}*/
							if (p1->validate()){ //finalize outer cycle
								cout << "After Validate (outer): " << *p1 << endl;
								f1.addOuterCycle(*p1);
								cout << "Added outer to face." << endl;
							}
							else
								cout << "Validation failed." << endl;
							
							//delete p1;
							
							while (true)
							{
								cout << "Do you want to add a hole to the face? (y/n)" << endl;
								cin >> option;
								if (option=="n"){
									cin.ignore(1);
									break; //get out of the while true
								}
								if (option=="y"){
									//poly2D hole=f1.addHole();
									poly2D *hole=new poly2D(); //memslob hole
									while (option!="n"){
										cin.ignore(1);
										cout << "Alright adding segments to the hole..." << endl;
										rational px,py,qx,qy;
										cout << "Enter x for p of this segment:";
										cin >> px;
										cout << "Enter y for p of this segment:";
										cin >> py;
										cout << "Enter x for q of this segment:";
										cin >> qx;
										cout << "Enter y for q of this segment:";
										cin >> qy;
										poi2D np(px,py);
										poi2D nq(qx,qy);
										seg2D ns(np,nq);						
										cout << "Built segment for hole: " << ns << endl;
										hole->addSegment(ns);
										cout << "Added segment...Want to add another one? (y/n)" << endl;
										cin >> option;
									}
/*									cout << "Before Validate (hole): " << *hole << endl;*/
									if (hole->validate()){
										cout << "After Validate (hole): " << *hole << endl;
										f1.addHole(*hole);
										cout << "Added hole to face." << endl;
									}
									else
										cout << "Validation failed." << endl;
									
									delete hole;
								}
							}
							if (f1.validate())
								cout << "Validated Face!" << endl;
						}else if (option=="r"){
							uint idface;
							cin.ignore(1);
							cout << "Region " << did << " has  " << ps.getFaceCount() << " faces. Which one do you want to remove?" << endl;
							cin >> idface;
							ps.removeFace(idface);
							cout << "Face removed." << endl;
						}else if (option=="q"){
							cin.ignore(1);
							quit2=true;
						}
						ps.validate();
						//p.commitBatch();
					}
					region.commitBatch();	
					checkerr(errhp, OCILobClose(svchp, errhp, mylob));
					checkerr(errhp, OCITransCommit(svchp, errhp, (ub4)0));
					delete blob1;
				}else
					cerr << "Problem retrieving newly created tuple" << endl;				

				checkerr(errhp, OCIHandleFree(stmthp,OCI_HTYPE_STMT));				
			}else if (option=="i" || option=="u" || option=="d" || option=="d2"){ //then select data and read
				
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp2,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));					
					
				if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
					(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
				{
					cout << "FAILED: OCIDescriptorAlloc() 1" << endl;
					return OCI_ERROR;
				}
				
				string id1, id2;
				
				cout << "Please give me the id of the first region:";
				cin >> id1;
				
				cout << "Please give me the id of the second region:";
				cin >> id2;
				
				string sqlQuery = "SELECT id,data FROM slobber where id=" + id1;
				string sqlQuery2 = "SELECT id,data FROM slobber where id=" + id2;

				
				//issue first SQL and process data
				checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
						 (ub4)strlen(sqlQuery.c_str()),
						 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
						 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
						 (ub2 *)0, OCI_DEFAULT));
	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
						 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
						 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
				if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
				{
					if (status == OCI_NO_DATA){
						cout << "First tuple not found!" << endl;
						break;
					}
					else
					{
						checkerr(errhp, status);
						if (envhp)
							(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
						return OCI_ERROR;
					}
				}else  //first tuple found, find the second now
					cout << "First tuple found! " << did << endl;
				
					if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob2,
						(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
					{
						cout << "FAILED: OCIDescriptorAlloc() 2" << endl;
						return OCI_ERROR;
					}
						
				//issue first SQL and process data
					checkerr(errhp, OCIStmtPrepare(stmthp2, errhp, (text *)(sqlQuery2.c_str()),
							 (ub4)strlen(sqlQuery2.c_str()),
							 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
					checkerr(errhp, OCIDefineByPos(stmthp2, &defnp3, errhp, 1, (dvoid *) &did2,
							 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
							 (ub2 *)0, OCI_DEFAULT));
	
					checkerr(errhp, OCIDefineByPos(stmthp2, &defnp4, errhp, (ub4) 2,
							 (dvoid *) &mylob2, (sb4) -1, (ub2) SQLT_BLOB,
							 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
					if (status = OCIStmtExecute(svchp, stmthp2, errhp, (ub4) 1, (ub4) 0,
						(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
					{
						if (status == OCI_NO_DATA){
							cout << "Second tuple not found!" << endl;
							break;
						}
						else
						{
							checkerr(errhp, status);
							if (envhp)
								(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
							return OCI_ERROR;
						}
					}else // second tuple found, success
						cout << "Second tuple found! " << did2 << endl;
				
						cout << "Tuples Found!, success?" << endl;
				
						if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
						{
							OCILobWrapper *blob1=new OCILobWrapper;
							OCILobWrapper *blob2=new OCILobWrapper;
				
							uint blength=0;
							checkerr(errhp, OCILobGetLength2(svchp, errhp, mylob, (oraub8*)&blength));
							cout << "Length of 1: " << blength << endl;
							blob1->lob=mylob;
							blob1->cntxt=svchp;
							blob1->errhp=errhp;
				
							checkerr(errhp, OCILobGetLength2(svchp, errhp, mylob2, (oraub8*)&blength));
							cout << "Length of 2: " << blength << endl;
							blob2->lob=mylob2;
							blob2->cntxt=svchp;
							blob2->errhp=errhp;
					
							mSlob p1(blob1);
							cout << "Built p1" << endl;
							mSlob p2(blob2);
							cout << "Built p2" << endl;
							cout << "mSLOBs Built from points" << endl;
					
							Locator daddy1(p1.locateGlobal());
							Locator region1(daddy1.locate(0));
					
							Locator daddy2(p2.locateGlobal());
							Locator region2(daddy2.locate(0));

					//					points.debug();
							region2D ps1(region1);
							region2D ps2(region2);
							region2D *result=new region2D();	

							cout << "The regions and the result: " << endl;
							cout << "P1: " << ps1 << endl;
							cout << "P2: " << ps2 << endl;
							if (option=="i") *result=ps1.intersection(ps2);
							if (option=="u") *result=ps1.sunion(ps2);
							if (option=="d") *result=ps1.difference(ps2);

							cout << "Computed operation, now will display..." << endl;

							if (option=="i") cout << "P1 * P2: " << *result << endl;
							if (option=="u") cout << "P1 + P2: " << *result << endl;
							if (option=="d") cout << "P1 - P2: " << *result << endl;
							if (option=="d2") cout << "dist(P1,P2): " << ps1.distance(ps2).toDouble() << endl;
					
							cout << "By Faces..." << endl;
							for (uint i=0; i<result->getFaceCount(); i++){
								face2D facy=result->getFace(i);
								cout << "Face " << (i+1) << " has " << facy.getHoleCount() << " holes: " << facy << endl;
							}
														
							
							delete result;

							checkerr(errhp, OCILobClose(svchp, errhp, mylob));
							delete blob1;
							checkerr(errhp, OCILobClose(svchp, errhp, mylob2));
							delete blob2;

							cout << "Beautifully displayed..." << endl;
				
						}else
							cout << "One of the regions was not found!" << endl;

				}else if(option =="cv" ||option == "t"){
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));
				checkerr(errhp, OCIHandleAlloc( (dvoid *) envhp, (dvoid **) &stmthp2,
						 OCI_HTYPE_STMT, (size_t) 0, (dvoid **) 0));					
					
				if (OCIDescriptorAlloc((dvoid *) envhp, (dvoid **) &mylob,
					(ub4)OCI_DTYPE_LOB, (size_t) 0, (dvoid **) 0))
				{
					cout << "FAILED: OCIDescriptorAlloc() 1" << endl;
					return OCI_ERROR;
				}
				
				string id1;
				
				cout << "Please give me the id of the region:";
				cin >> id1;
				
								
				string sqlQuery = "SELECT id,data FROM slobber where id=" + id1;
								
				//issue first SQL and process data
				checkerr(errhp, OCIStmtPrepare(stmthp, errhp, (text *)(sqlQuery.c_str()),
						 (ub4)strlen(sqlQuery.c_str()),
						 (ub4) OCI_NTV_SYNTAX, (ub4) OCI_DEFAULT));	
		
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp, errhp, 1, (dvoid *) &did,
						 (sword) sizeof(int), SQLT_INT, (dvoid *) 0, (ub2 *)0,
						 (ub2 *)0, OCI_DEFAULT));
	
				checkerr(errhp, OCIDefineByPos(stmthp, &defnp2, errhp, (ub4) 2,
						 (dvoid *) &mylob, (sb4) -1, (ub2) SQLT_BLOB,
						 (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) OCI_DEFAULT));
				
				if (status = OCIStmtExecute(svchp, stmthp, errhp, (ub4) 1, (ub4) 0,
					(CONST OCISnapshot *) NULL, (OCISnapshot *) NULL, OCI_DEFAULT))
				{
					if (status == OCI_NO_DATA){
						cout << "First tuple not found!" << endl;
						break;
					}
					else
					{
						checkerr(errhp, status);
						if (envhp)
							(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
						return OCI_ERROR;
					}
				}else{/* region found */
					if (status==OCI_SUCCESS || status==OCI_SUCCESS_WITH_INFO)
					{
						OCILobWrapper *blob1=new OCILobWrapper;
						
				
						uint blength=0;
						checkerr(errhp, OCILobGetLength2(svchp, errhp, mylob, (oraub8*)&blength));
						cout << "Length of 1: " << blength << endl;
						blob1->lob=mylob;
						blob1->cntxt=svchp;
						blob1->errhp=errhp;
						
						mSlob p1(blob1);
						cout << "Built p1" << endl;
						cout << "mSLOBs Built from points" << endl;
					
						Locator daddy1(p1.locateGlobal());
						Locator region1(daddy1.locate(0));
					
						
						if(option == "cv"){
							region2D ps1(region1);
							region2D *result=new region2D();	

							cout << "The regions and the result: " << endl;
							cout << "P1: " << ps1 << endl;
							*result=ps1.convexHull();
							cout << "Computed operation, now will display..." << endl;
							
							cout << "convex " << *result << endl;
						
							cout << "By Faces..." << endl;
							for (uint i=0; i<result->getFaceCount(); i++){
								face2D facy=result->getFace(i);
								cout << "Face " << (i+1) << " has " << facy.getHoleCount() << " holes: " << facy << endl;
							}
							delete result;
	
						}else{
							region2D ps1(region1);
							line2D *result=new line2D();	
							*result = ps1.delaunayTriangulation();
							for(uint i =0; i<result->getBlockCount();i++){
								block2D bl = result->getBlock(i);
								cout<<"block"<<(i+1)<<bl<<endl;
							}
							delete result;

						}
						
						
						checkerr(errhp, OCILobClose(svchp, errhp, mylob));
						delete blob1;
							
						cout << "Beautifully displayed..." << endl;
				}
				
			}
			}else if (option=="quit")
				quit=true;
		}
		
		cout << "Thanks for testing with us!!!" << endl;
		cout << "Closing connection" << endl;
		if (srvhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SERVER);
		if (svchp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SVCCTX);
		if (errhp)
			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_ERROR);
		if (envhp)
			(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
// 	}
// 	catch (exception &excp)
// 	{
// 		cerr << excp.what() << endl;
// 		cout << "Thanks...sorry we ended this on such a bad note." << endl;
// 		cout << "Closing connection" << endl;
// 		
// 		if (srvhp)
// 			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SERVER);
// 		if (svchp)
// 			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_SVCCTX);
// 		if (errhp)
// 			(void) OCIHandleFree((dvoid *) errhp, OCI_HTYPE_ERROR);
// 		if (envhp)
// 			(void) OCIHandleFree((dvoid *) envhp, OCI_HTYPE_ENV);
// 		throw excp;
// 	}
}


